package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type AddSecurityGroupToServerLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewAddSecurityGroupToServerLogic(ctx context.Context, svcCtx *svc.ServiceContext) *AddSecurityGroupToServerLogic {
	return &AddSecurityGroupToServerLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *AddSecurityGroupToServerLogic) AddSecurityGroupToServer(req *types.AddSecurityGroupToServerReq) (resp *types.AddSecurityGroupToServerResp, err error) {
	// todo: add your logic here and delete this line
	AddSecurityGroupToServerReq := &openstack.AddSecurityGroupToServerReq{}
	err = copier.CopyWithOption(AddSecurityGroupToServerReq, req, copier.Option{Converters: utils.Converters})
	AddSecurityGroupToServerResp, err := l.svcCtx.OpenstackRpc.AddSecurityGroupToServer(l.ctx, AddSecurityGroupToServerReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&AddSecurityGroupToServerResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &AddSecurityGroupToServerResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
